.doc {
  @apply text-gray-900 dark:text-gray-300;
  margin: 0 auto;
  max-width: 40rem;
  padding: 0 1rem 4rem;
}

@media (min-width: 1024px) {
  .doc {
    margin: 0 2rem;
    max-width: 54rem;
    min-width: 0;
  }
}

.toc .title{
  font-family: "Open sans", Helvetica, Arial;
  font-size: 24px;
  color: #191919;
  font-weight: 600;
}

.doc h1 {
  font-weight: 600;
  line-height: 1.3;
}

.doc h2,
.doc h3,
.doc h4,
.doc h5,
.doc h6 {
  font-weight: 600;
  line-height: 1.3;
  margin: 1rem 0 0;
}

article.doc h1 {
  font-weight: 600;
}

ul.nav-list {
  font-family: "Open sans", Helvetica, Arial;
}


.doc h3 {
  font-family: "Open sans", Helvetica, Arial;
  font-size: 24px;
}

/* Add an H4 heading to fix issues with H4 content displaying same size as H2 */
.doc h4 {
  font-family: "Open sans", Helvetica, Arial;
  font-size: 20px;
}

.doc h1 > a.anchor,
.doc h2 > a.anchor,
.doc h3 > a.anchor,
.doc h4 > a.anchor,
.doc h5 > a.anchor,
.doc h6 > a.anchor {
  position: absolute;
  text-decoration: none;
  width: 1.75ex;
  margin-left: -1.5ex;
  visibility: hidden;
  font-size: 0.8em;
  font-weight: normal;
  padding-top: 0.05em;
}

.doc h1 > a.anchor::before,
.doc h2 > a.anchor::before,
.doc h3 > a.anchor::before,
.doc h4 > a.anchor::before,
.doc h5 > a.anchor::before,
.doc h6 > a.anchor::before {
  content: "\00a7";
}

.doc h1:hover > a.anchor,
.doc h2:hover > a.anchor,
.doc h3:hover > a.anchor,
.doc h4:hover > a.anchor,
.doc h5:hover > a.anchor,
.doc h6:hover > a.anchor {
  visibility: visible;
}

.doc a,
.doc a:visited {
  @apply text-fp-blue dark:text-fp-blue-light;
}

.doc a:hover {
  @apply text-fp-blue-dark dark:text-fp-blue;
}

.doc i.fa {
  font-style: normal;
}

/* what about td/th code? */
.doc p code {
  font-size: 0.9em;
  padding: 0.075rem 0.25rem 0.125rem;
  border-radius: 0.2rem;
  /* font-weight: 300; */
}

.doc pre {
  /* color: #000; */
  font-size: 0.9rem;
  line-height: 1.5;
  margin: 0;
}

.doc .paragraph,
.doc .colist,
.doc .dlist,
.doc .olist,
.doc .ulist,
.doc .hdlist,
.doc .exampleblock,
.doc .imageblock,
.doc .listingblock,
.doc .literalblock,
.doc .sidebarblock {
  margin: 1rem 0 0;
}
@media (min-width: 1024px) {
  .doc .sidebarblock.width50 {
    width: 54%;
    float: right;
    margin: 0 -20px 0 20px;
    border: 20px white solid;
  }

  .doc .sidebarblock.width33 {
    width: 39%;
    float: right;
    margin: 0 -20px 0 20px;
    border: 20px white solid;
  }
}

.doc table.tableblock {
  font-size: 0.8rem;
}

.doc .tablecontainer,
.doc .tablecontainer + *,
.doc :not(.tablecontainer) > table.tableblock,
.doc :not(.tablecontainer) > table.tableblock + * {
  margin-top: 1.5rem;
}

.doc p.tableblock + p.tableblock {
  margin-top: 0.5rem;
}

.doc td.tableblock > .content > :first-child {
  margin-top: 0;
}

.doc table.tableblock {
  border-collapse: collapse;
  margin: 2rem 0;
  /* enable table-layout: fixed if you want the table width to be enforced strictly */
  /* alternative is to wrap table in div and set overflow-x: auto on the wrapper */
  /* table-layout: fixed; */
}

.doc table.spread {
  width: 100%;
}

.doc table.tableblock th,
.doc table.tableblock td {
  padding: 0.5rem;
}

.doc table.tableblock th {
  @apply border-b-2 border-b-gray-300 dark:border-b-gray-700;
}

.doc table.tableblock td {
  @apply border-y border-y-gray-300 dark:border-y-gray-700;
}

/*
.doc table.tableblock,
.doc table.tableblock > * > tr > * {
  @apply border-0 border-gray-100 dark:border-gray-100;
}

.doc table.grid-all > * > tr > * {
  border-width: 1px;
}

.doc table.grid-cols > * > tr > * {
  border-width: 0 1px;
}

.doc table.grid-rows > * > tr > * {
  border-width: 1px 0;
}

.doc table.grid-all > thead th,
.doc table.grid-rows > thead th {
  border-bottom-width: 2.5px;
}

.doc table.frame-all {
  border-width: 1px;
}

.doc table.frame-ends {
  border-width: 1px 0;
}

.doc table.frame-sides {
  border-width: 0 1px;
}

.doc table.frame-none > colgroup + * > :first-child > *,
.doc table.frame-sides > colgroup + * > :first-child > * {
  border-top-width: 0;
}


/* NOTE let the grid win in case of frame-none 
.doc table.frame-sides > :last-child > :last-child > * {
  border-bottom-width: 0;
}

.doc table.frame-none > * > tr > :first-child,
.doc table.frame-ends > * > tr > :first-child {
  border-left-width: 0;
}

.doc table.frame-none > * > tr > :last-child,
.doc table.frame-ends > * > tr > :last-child {
  border-right-width: 0;
}

.doc table.stripes-all > tbody > tr,
.doc table.stripes-odd > tbody > tr:nth-of-type(odd),
.doc table.stripes-even > tbody > tr:nth-of-type(even),
.doc table.stripes-hover > tbody > tr:hover {
  @apply bg-gray-900 dark:bg-gray-100;
}

.doc table.tableblock > tfoot {
  @apply bg-fp-gray-lightest dark:bg-fp-gray-darkest;
}
*/

.doc .halign-left {
  text-align: left;
}

.doc .valign-top {
  vertical-align: top;
}

.doc .tableblock p {
  font-size: inherit;
}

.doc .admonitionblock {
  margin: 1.4rem 0 0;
}

.doc .admonitionblock p,
.doc .admonitionblock td.content {
  font-size: 0.9rem;
}

.doc .admonitionblock td.content > :not(.title):first-child,
.doc .admonitionblock td.content > .title + * {
  margin-top: 0;
}

.doc .admonitionblock pre {
  font-size: 0.85rem;
}

.doc .admonitionblock > table {
  border-collapse: separate;
  table-layout: fixed;
  position: relative;
  width: 100%;
}

.doc .admonitionblock td.content {
  padding: 3rem 1rem 0.75rem;
  width: 100%;
}

.doc .admonitionblock .icon {
  font-size: 4.5rem;
  padding: 0 0.5rem;
  height: 1.5rem;
  line-height: 1;
  font-weight: 500;
  transform: translate(0.8rem, -50%);
}

.doc .admonitionblock .icon .fa {
  @apply font-display font-bold text-xl;
  background-position-y: center;
  background-repeat: no-repeat;
  padding-left: 42px;
}

.doc .admonitionblock.caution .icon-caution {
  background-image: url(../img/icon-caution.png);
  color: #e59728;
  background-position-x: 3px;
}

.doc .admonitionblock.important .icon-important {
  background-image: url(../img/icon-important.png);
  color: #a07cbc;
  background-position-x: 4px;
}

.doc .admonitionblock.note .icon-note {
  background-image: url(../img/icon-note.png);
  color: #51a2da;
  background-position-x: 3px;
}

.doc .admonitionblock.tip .icon-tip {
  background-image: url(../img/icon-tip.png);
  color: #79db32;
  background-position-x: 8px;
}

.doc .admonitionblock.warning .icon-warning {
  background-image: url(../img/icon-warning.png);
  color: #db3279;
}

.doc .admonitionblock.caution td.content {
  border-left: 8px solid #e59728;
  border-radius: 8px;
}

.doc .admonitionblock.important td.content {
  border-left: 8px solid #a07cbc;
  border-radius: 8px;
}

.doc .admonitionblock.note td.content {
  border-left: 8px solid #51a2da;
  border-radius: 8px;
}

.doc .admonitionblock.tip td.content {
  border-left: 8px solid #79db32;
  border-radius: 8px;
}

.doc .admonitionblock.warning td.content {
  border: 1px solid #db3279;
  border-left-width: 8px;
  border-bottom-left-radius: 8px;
  border-top-left-radius: 8px;
}

.doc .admonitionblock .icon i {
  display: inline-flex;
  align-items: center;
  /* height: 100%; */
  /* height value causing issues in Chrome, pushing admonition icon and text too high and off center */
}

.doc .admonitionblock .icon i::after {
  content: attr(title);
  hyphens: none;
}

.doc .imageblock {
  display: flex;
  flex-direction: column;
  align-items: center;
}

.doc .imageblock img {
  display: block;
}

.doc .imageblock img,
.doc .paragraph .image img {
  height: auto;
  max-width: 100%;
}

.doc > h1 {
  font-size: 2rem;
}

#preamble + .sect1,
.doc .sect1 + .sect1 {
  margin-top: 2.5rem;
}

.doc h2:not(.discrete) {
  border-bottom: 1px solid #ddd;
  margin-left: -1rem;
  margin-right: -1rem;
  padding: 0.4rem 1.5rem 0.1rem;
  font-size: 36px;
  font-weight: 700;
}

article.doc h2 {
  border-bottom: solid #0275d8!important;
  padding: .4rem 0.9rem .1rem!important;
}

.doc p {
  font-size: 18px;
  margin: 0;
}

.doc p,
.doc .tableblock,
.doc .content {
  hyphens: auto;
}

.doc .content pre {
  -webkit-hyphens: none;
  -ms-hyphens: none;
  hyphens: none;
}

/*
.doc .ulist .paragraph,
.doc .olist .paragraph {
  margin: 0;
  padding: 0;
}
*/

#preamble .abstract blockquote {
  background: var(--abstract-background);
  border-left: 5px solid var(--abstract-border-color);
  color: var(--abstract-font-color);
  font-size: calc(16 / var(--rem-base) * 1rem);
  margin: 0;
  padding: 0.75em 1em;
}

.doc table.tableblock .paragraph {
  margin: 0;
  padding: 0;
}

.doc table.tableblock .admonitionblock,
.doc .ulist .admonitionblock,
.doc .olist .admonitionblock {
  padding: 0;
}

.doc ul {
  margin: 0;
  padding: 0 0 0 1.5rem;
}

.doc ol {
  margin: 0;
  padding: 0 0 0 2rem;
  list-style: none;
  counter-reset: ordered-list;
}

.doc ol > li {
  counter-increment: ordered-list;
}

.doc ol > li::before {
  font-weight: 500;
  font-size: 0.95em;
  display: inline-block;
  width: 1em;
  direction: rtl;
  /* NOTE the browser uses -1.25em as left offset */
  margin: -0.025em 0.5em 0 -1.5em;
  text-align: right;
  position: absolute;
}

.doc ol.arabic > li::before {
  content: "." counter(ordered-list);
}

/* NOTE decimal-leading-zero not yet supported; @counter-style not supported in Chrome */

.doc ol.loweralpha > li::before {
  content: "." counter(ordered-list, lower-alpha);
}

.doc ol.lowergreek > li::before {
  content: "." counter(ordered-list, lower-greek);
}

.doc ol.lowerroman > li::before {
  content: "." counter(ordered-list, lower-roman);
}

.doc ol.upperalpha > li::before {
  content: "." counter(ordered-list, upper-alpha);
}

.doc ol.upperroman > li::before {
  content: "." counter(ordered-list, upper-roman);
}

.doc ul.checklist {
  list-style: none;
}

.doc ul.checklist p > i.fa-check-square-o:first-child,
.doc ul.checklist p > i.fa-square-o:first-child {
  display: inline-flex;
  justify-content: center;
  width: 1rem;
  margin-right: 0.25rem;
  margin-left: -1.5rem;
}

.doc ul.checklist i.fa-check-square-o::before {
  content: "\2713";
}

.doc ul.checklist i.fa-square-o::before {
  content: "\274f";
}

.doc .dlist .dlist,
.doc .dlist .olist,
.doc .dlist .ulist,
.doc .olist .dlist,
.doc .olist .olist,
.doc .olist .ulist,
.doc .ulist .dlist,
.doc .ulist .olist,
.doc .ulist .ulist {
  margin-top: 0.5rem;
}

.doc .olist li,
.doc .ulist li {
  margin-bottom: 0.5rem;
}

.doc .ulist .listingblock,
.doc .olist .listingblock,
.doc .admonitionblock .listingblock {
  padding: 0;
}

.doc .admonitionblock .title,
.doc .exampleblock .title,
.doc .imageblock .title,
.doc .literalblock .title,
.doc .listingblock .title,
.doc .tableblock caption {
  color: var(--caption-font-color);
  font-size: calc(16 / var(--rem-base) * 1rem);
  font-style: var(--caption-font-style);
  font-weight: var(--caption-font-weight);
  letter-spacing: -0.01em;
  padding-bottom: 0.075rem;
}

/*
.doc .tableblock caption {
  text-align: left;
}
*/

.doc .tableblock caption {
  font-style: normal;
}

.doc .ulist .title,
.doc .olist .title {
  font-style: italic;
  font-weight: 600;
  margin-bottom: 0.25rem;
}

.doc .imageblock .title {
  margin-top: 0.5rem;
  padding-bottom: 0;
}

.doc .admonitionblock .title + .paragraph {
  margin-top: 0;
}

/* Other possible colors #248232 (dark green) #2ba84a (brighter green), #f7ef99 (soft yellow), #f78e69 (orangey-grayish) */
.doc .exampleblock > .content {
  box-shadow: inset 0 0 1.75px #248232;
  padding: 0.75rem;
}

.doc .exampleblock > .content > :first-child {
  margin-top: 0;
}

.doc .sidebarblock {
  @apply bg-fp-gray-lighter dark:bg-gray-900;
  padding: 0.75rem 1.5rem;
}

.doc .sidebarblock > .content > .title {
  @apply text-gray-800 dark:text-gray-200;
  font-size: 1.2rem;
  font-weight: 500;
  line-height: 1.3;
  margin-bottom: -0.3em;
  text-align: center;
}

.doc .sidebarblock > .content > :not(.title):first-child {
  margin-top: 0;
}

/* NEEDS REVIEW prevent pre in table from causing article to exceed bounds */
.doc .tableblock pre,
.doc .listingblock.wrap pre {
  white-space: pre-wrap;
}

.doc pre:not(.highlight),
.doc pre.highlight code {
  display: block;
  overflow-x: auto;
  padding: 0.75rem;
}

.doc .listingblock > .content {
  position: relative;
}

.doc .source-toolbox {
  display: flex;
  visibility: hidden;
  position: absolute;
  top: 0.25rem;
  right: 0.5rem;
  font-size: 0.725rem;
  line-height: 1;
  white-space: nowrap;
  z-index: 1;
}

.doc .listingblock:hover .source-toolbox {
  visibility: visible;
}

/*
.doc .source-toolbox .source-lang {
  text-transform: uppercase;
  letter-spacing: 0.075em;
}
*/

.doc .source-toolbox > :not(:last-child)::after {
  content: "|";
  letter-spacing: 0;
  padding: 0 1ch;
}

.doc .source-toolbox .copy-button {
  display: flex;
  flex-direction: column;
  align-items: center;
  background: none;
  border: none;
  color: inherit;
  outline: none;
  padding: 0;
  font-size: inherit;
  line-height: inherit;
  width: 1em;
  height: 1em;
}

.doc .source-toolbox .copy-icon {
  flex: none;
  width: inherit;
  height: inherit;
}

.doc .source-toolbox img.copy-icon {
  filter: invert(50.2%);
}

.doc .source-toolbox svg.copy-icon {
  fill: currentColor;
}

.doc .source-toolbox .copy-toast {
  flex: none;
  position: relative;
  display: inline-flex;
  justify-content: center;
  margin-top: 1em;
  @apply bg-fp-gray-darkest dark:bg-fp-gray-lighter;
  border-radius: 0.25em;
  padding: 0.5em;
  @apply text-white dark:text-black;
  cursor: auto;
  opacity: 0;
  transition: opacity 0.5s ease 0.5s;
}

.doc .source-toolbox .copy-toast::after {
  content: "";
  position: absolute;
  top: 0;
  width: 1em;
  height: 1em;
  border: 0.55em solid transparent;
  @apply border-l-fp-gray-darkest dark:border-l-fp-gray-lighter;
  transform: rotate(-90deg) translateX(50%) translateY(50%);
  transform-origin: left;
}

.doc .source-toolbox .copy-button.clicked .copy-toast {
  opacity: 1;
  transition: none;
}

.doc .language-console .hljs-meta {
  user-select: none;
}

.doc .dlist dt {
  @apply text-fp-gray-darkest dark:text-fp-gray-lightest;
  font-style: italic;
}

.doc .dlist dd {
  margin: 0 0 0.3rem 1.5rem;
}

.doc .dlist dd:last-of-type {
  margin-bottom: 0;
}

.doc td.hdlist1,
.doc td.hdlist2 {
  padding: 0.5rem 0 0;
  vertical-align: top;
}

.doc tr:first-child > .hdlist1,
.doc tr:first-child > .hdlist2 {
  padding-top: 0;
}

.doc td.hdlist1 {
  font-weight: 600;
  padding-right: 0.25rem;
}

.doc td.hdlist2 {
  padding-left: 0.25rem;
}


.doc .colist {
  font-size: 0.95rem;
  margin: 0.25rem 0 -0.25rem;
}

.doc .colist > table > tr > :first-child,
.doc .colist > table > tbody > tr > :first-child {
  padding: 0.25em 0.5rem 0;
  vertical-align: top;
  line-height: 1;
}

.doc .colist > table > tr > :last-child,
.doc .colist > table > tbody > tr > :last-child {
  padding: 0.25rem 0;
}

.doc .conum[data-value] {
  /* border: 1px solid #989898; */
  border: 1px solid #404040;
  border-radius: 100%;
  display: inline-block;
  font-family: "Roboto", sans-serif;
  font-size: 0.75rem;
  font-style: normal;
  height: 1.25em;
  line-height: 1.2;
  text-align: center;
  width: 1.25em;
  letter-spacing: -0.25ex;
  text-indent: -0.25ex;
}

.doc .conum[data-value]::after {
  content: attr(data-value);
}

.doc .conum[data-value] + b {
  display: none;
}

.doc .colist {
  font-size: 0.95rem;
}

.doc .colist > table tr > td:first-of-type {
  padding: 0 0.75em;
  line-height: 1;
}

.doc td.hdlist1,.doc td.hdlist2 {
  padding: .5rem 0 0;
  vertical-align: top
}

.doc tr:first-child>.hdlist1,.doc tr:first-child>.hdlist2 {
  padding-top: 0
}

.doc td.hdlist1 {
  font-weight: 600;
  padding-right: .25rem
}

.doc td.hdlist2 {
  padding-left: .25rem
}

.doc hr {
  @apply border-t-2 border-t-fp-gray-lighter dark:border-t-fp-gray-dark;
  height: 0;
}

.doc b.button {
  white-space: nowrap; /* effectively ignores hyphens setting */
}

b.button::before {
  content: "[";
  padding-right: 0.25em;
}

b.button::after {
  content: "]";
  padding-left: 0.25em;
}

kbd {
  color: black;
  display: inline-block;
  font-size: 0.7rem;
  background-color: #fafafa;
  border: 1px solid #c1c1c1;
  border-radius: 0.25em;
  box-shadow: 0 1px 0 #c1c1c1, 0 0 0 0.1em #fff inset;
  padding: 0.25em 0.5em;
  vertical-align: text-bottom;
  white-space: nowrap;
}

kbd,
.keyseq {
  line-height: 1;
}

.keyseq {
  font-family: "Roboto Mono", monospace;
  font-size: 0.9em;
}

.keyseq kbd {
  margin: 0 0.125em;
}

.keyseq kbd:first-child {
  margin-left: 0;
}

.keyseq kbd:last-child {
  margin-right: 0;
}

.menuseq i.caret::before {
  content: ">";
  font-weight: 500;
}

.qanda li p:first-child {
  font-weight: 600;
  margin-top: 20px;
  margin-left: -20px;
}

.imageblock.profile-picture {
  float: right;
  margin-left: 30px;
  width: 140px;
}

.imageblock.profile-picture img {
  border-radius: 8px;
}

/* Don't leave ocean of space between table and info text */
.doc table.tableblock + div.dataTables_info {
  margin-top: -2rem;
  margin-bottom: 2rem;
}

/* Dark mode styling for extra dataTables content */
.doc .dataTables_filter,
.doc .dataTables_info {
  @apply text-fp-gray-dark dark:text-fp-gray-light;
}

/* Recreate jqueryui-datatables table row striping with dark mode */
.doc table.dataTable.stripe > tbody > tr.odd > *,
.doc table.dataTable.display > tbody > tr.odd > * {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.023)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.04)];
}

.doc table.dataTable.hover > tbody > tr:hover > *,
.doc table.dataTable.display > tbody > tr:hover > * {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.035)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.06)];
}

.doc table.dataTable.order-column > tbody tr > .sorting_1,
.doc table.dataTable.order-column > tbody tr > .sorting_2,
.doc table.dataTable.order-column > tbody tr > .sorting_3,
.doc table.dataTable.display > tbody tr > .sorting_1,
.doc table.dataTable.display > tbody tr > .sorting_2,
.doc table.dataTable.display > tbody tr > .sorting_3 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.019)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.029)];
}

.doc table.dataTable.display > tbody > tr.odd > .sorting_1,
.doc table.dataTable.order-column.stripe > tbody > tr.odd > .sorting_1 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.054)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.08)];
}

.doc table.dataTable.display > tbody > tr.even > .sorting_1,
.doc table.dataTable.order-column.stripe > tbody > tr.even > .sorting_1 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.019)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.035)];
}

.doc table.dataTable.display > tbody > tr.even > .sorting_2,
.doc table.dataTable.order-column.stripe > tbody > tr.even > .sorting_2 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.011)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.02)];
}

.doc table.dataTable.display > tbody > tr.even > .sorting_3,
.doc table.dataTable.order-column.stripe > tbody > tr.even > .sorting_3 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.003)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.006)];
}

.doc table.dataTable.display tbody tr:hover > .sorting_1,
.doc table.dataTable.order-column.hover tbody tr:hover > .sorting_1 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.082)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.1)];
}

table.dataTable.display tbody tr:hover > .sorting_2,
table.dataTable.order-column.hover tbody tr:hover > .sorting_2 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.074)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.09)];
}

table.dataTable.display tbody tr:hover > .sorting_3,
table.dataTable.order-column.hover tbody tr:hover > .sorting_3 {
  @apply shadow-[inset_0_0_0_9999px_rgba(0,0,0,0.062)] dark:shadow-[inset_0_0_0_9999px_rgba(255,255,255,0.075)];
}
